<template>
  <span :id="id">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || (field.textType && field.textType == 'hidden')"
    >
      <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->
      <input type="hidden" v-model="field.value" />
      <div class="photos-online" v-if="field.mobile&&field.hiddenValue">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
        </div>
        <div class="view-li">
          <div class="view-li-right">
            {{field.hiddenValue}}
          </div>
        </div>
      </div>
    </template>

    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <div class="photos-online">
        <!--开启摄像头-->
        <div class="titleName">{{field.discript?field.discript:field.name}}</div>
        <div class="pic-wrap">
          <div class="add"  @click="takePhotos">
            <div class="add-image">
              <img src="../assets/images/Shape.png" />
            </div>
          </div>
          <template v-if="field.imgList && field.imgList.length>0">
            <div class="add img-bg" v-for="(item,index) in field.imgList" :key="index">
              <div class="images">
                <img :src="item" @click="picturePreview(item)"/>
              </div>
              <div class="close" @click="deletePhoto(item,index)">
                <i class="fa fa-times-circle"></i>
              </div>
            </div>
          </template>
          <input
            :id="field.divId"
            type="file"
            class="file-input"
            accept="image/png, image/jpeg, image/jpg"
            :multiple="multiple"
            @change="inputChange"
            style="display: none"
          />
        </div>
      </div>
    </template>

    <template
      v-else-if="field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED"
    >
    <div class="photos-online">
      <div class="titleName">{{field.discript?field.discript:field.name}}</div>
      <div class="pic-wrap">
        <div class="add" >
          <div class="add-image">
            <img src="../assets/images/Shape.png" />
          </div>
        </div>
        <template v-if="field.imgList && field.imgList.length>0">
          <div class="add img-bg" v-for="(item,index) in field.imgList" :key="index">
            <div class="images">
              <img :src="item" @click="picturePreview(item)"/>
            </div>
            <div class="close" @click="deletePhoto(item,index)">
              <i class="fa fa-times-circle"></i>
            </div>
          </div>
        </template>
      </div>
    </div>
    </template>
    <van-image-preview v-model="popupVisible" :images="field.imgList"></van-image-preview>
  </span>
</template>

<script>
import wx from "weixin-js-sdk"
import Constant from "@/Constant.js"
import API from "@/api.js"
import { Toast } from "mint-ui"
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-photo",
  props: ["id"],
  computed: {
    field: function() {
      let formData = this.$parent.findField(this.id);
      let accessToken = "?accessToken=" + this.accessToken
      if(typeof formData.value == "string") {
        if(formData.value.charAt(0) == '[') {
          // if(formData.value && formData.value.length>0) {
          //   formData.value = formData.value.replace(/\\|\[|\]|"/g,"");
          //   formData.imgURL = formData.value.split(",")
          //   let host = "http://" + window.location.host + "/obpm";
          //   for(let i=0; i<formData.imgURL.length; i++) {
          //     let temp =  host + formData.imgURL[i];
          //     formData.imgURL[i] = temp;
          //   }
          // }
          formData.value = formData.value.replace(/&quot;/g,"\"");
          let value = eval('(' + formData.value+ ')');
          formData.imgURL = JSON.parse(JSON.stringify(value)); //迫于无奈;
          formData.imgList = JSON.parse(JSON.stringify(value));
          let list = formData.imgList;
          for (let i = 0; i < list.length; i++) {
            list[i] = obpmConfig.obpmFilePath + list[i] + accessToken;
          }
        }
      }else if(formData.value instanceof Array) {
        formData.imgURL = JSON.parse(JSON.stringify(formData.value));
        formData.imgList = JSON.parse(JSON.stringify(formData.value));
        let list = formData.imgList;
        for (let i = 0; i < list.length; i++) {
          list[i] = obpmConfig.obpmFilePath + list[i] + accessToken;
        }
      }
      return formData;
    }
  },
  mounted() {
    window['onClickToTakePhoto'] = (res)=> {
      this.onClickToTakePhoto(res);
    }
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },
  data: function() {
    return {
      Constant,
      dialogVisible: false,
      photo: "",
      savePhoto: "",
      photoURL:[],
      value:'',
      popupVisible:false,
      datas:'',
      multiple: true,
      resData: "00",
      accessToken: localStorage.getItem("accessToken")
    };
  },
  methods: {
    async inputChange(e) {
      let files = e.target.files;
      [].slice.call(files, 0).map(this.upload);
      //let result = await Promise.all(uploadAll);
      document.getElementById(this.field.divId).value = "";
    },

    upload(file) {
      let nameArr = file.name.split(".");
      let name = nameArr[nameArr.length -1];
			let arr = ['jpeg','png','gif','jpg', 'JPG', 'JPEG', 'PNG', 'GIF'];
			let isSuffix = arr.indexOf(name) > 0;
      if(!isSuffix) {
        this.dialogVisible = false;
        Toast("图片类型错误");
        return
      }

      let that = this;
      return new Promise(async () => {
        let form = new FormData();
        form.append("files", file);
        let files = form;
        let actionType = this.imageType;
        let appId = this.$root.appid;
        let allowedTypes = this.field.fileType;
        let fieldId = this.id;
        let fileSaveMode = this.field.fileSaveMode;
        let path = 'uploads';
        this.$api.uploadFile(
          files, 
          appId, 
          allowedTypes,  
          fieldId, 
          fileSaveMode, 
          path, 
          actionType,
          {
            onSucess: response => {
              if(response.data.data) {
                let datas = response.data.data;
                let arr = [];
                for(let i=0; i<datas.length; i++) {
                  arr.push(datas[i].filePath);
                }
                let val = that.field.imgURL;
                if(val) {
                  val = val || [];
                  val = val.concat(arr);
                  that.field.value = val
                }else {
                  that.field.value = arr //val.concat(arr);
                }
              }
            }
          },
          () =>{
           
          },
        )
      });
    },

    onClickToTakePhoto(res) {
      let currentfieldId = localStorage.getItem("currentTakePhotoFieldId");
      let datas = JSON.parse(res);
      let arr = [];
      for(let i=0; i<datas.length; i++) {
        arr.push(datas[i].path);
      }
      let list = this.$parent.getAllFields();
      for(let i=0; i<list.length; i++) {
        if(currentfieldId == list[i].id) {
          list[i].value = arr;
        }
      }
      // this.field.value = arr;
    },

     //图片预览
    picturePreview(){
      this.popupVisible = true;
    },

    deletePhoto(path,index) {
      let field = this.field;
      let appId = this.$root.appid;
      let formId = field.formId;
      let docId = field.docId;
      this.$api.deleteUpload(appId, formId, docId, path, {
        onSucess: (res) => {
          if(res.data.errcode == 0) {
            for(let i=0; i<field.value.length; i++) {
              if(index == i) {
                field.value.splice(i, 1);
                this.$forceUpdate();
              }
            }
          }
        }
      });
    },

    takePhotos() {
      localStorage.setItem('currentTakePhotoFieldId',this.field.id);
      let ua = window.navigator.userAgent;
      let that = this;
      let sourcetype = [];
      if(this.field.album == 'true') {
        sourcetype = ["album", "camera"];
      }else if(this.field.album == 'false'){
        sourcetype = ["camera"];
      }
      if(ua.indexOf("myApps") >= 0) { //嗨办公
        // this.uploadImageWithNative();
        let count = 3;
        this.uploadImageWithNative({
          fileSaveMode: '00',//存盘模式，默认值‘00’ 
          path: 'ITEM_PATH',//存盘路径，默认值‘ITEM_PATH’ 
          fieldId: that.field.divId,//表单控件id 
          applicationId: that.$root.appid,//软件应用id 
          count: count, // 文件数量，默认9，当文件数量1时，仅允许选择一个文件 
          sourceType: sourcetype,  //['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
          result: (res) => {
            onClickToTakePhoto(res);
          }
        });
      }else if (ua.toLowerCase().indexOf("wxwork") >= 0 || ua.toLowerCase().indexOf("weixin") >= 0){
        let _url = location.href.split("#")[0];
        API.getWeixinApi(
          encodeURIComponent(_url),
          {
            onSucess: response => {
              let that = this;
              wx.config({
                debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
                appId: response.data.data.appId, // 必填，公众号的唯一标识
                timestamp: response.data.data.timestamp, // 必填，生成签名的时间戳
                nonceStr: response.data.data.nonceStr, // 必填，生成签名的随机串
                signature: response.data.data.signature, // 必填，签名，见附录1
                jsApiList: [
                  "checkJsApi",
                  "onMenuShareTimeline",
                  "onMenuShareAppMessage",
                  "onMenuShareQQ",
                  "onMenuShareWeibo",
                  "hideMenuItems",
                  "showMenuItems",
                  "hideAllNonBaseMenuItem",
                  "showAllNonBaseMenuItem",
                  "translateVoice",
                  "startRecord",
                  "stopRecord",
                  "onRecordEnd",
                  "playVoice",
                  "pauseVoice",
                  "stopVoice",
                  "uploadVoice",
                  "downloadVoice",
                  "chooseImage",
                  "previewImage",
                  "uploadImage",
                  "downloadImage",
                  "getNetworkType",
                  "openLocation",
                  "getLocation",
                  "hideOptionMenu",
                  "showOptionMenu",
                  "closeWindow",
                  "scanQRCode",
                  "chooseWXPay",
                  "openProductSpecificView",
                  "addCard",
                  "chooseCard",
                  "openCard"
                ] // 必填，需要使用的JS接口列表，所有JS接口列表见附录2
              });
              
              wx.chooseImage({
                count: 9,
                sizeType: ["original", "compressed"], // o：原图，c：压缩图
                sourceType: sourcetype, // a：来自相册，c：来自相机
                success: function(res) {
                  that.uploadFile(res.localIds);
                },
                fail: function(error) {
                  alert("网络异常，请再次尝试！");
                }
              });
            }
          }
        );
      }else {
        document.getElementById(this.field.divId).click();
      }
    },

    uploadImageWithNative(callback){
      let that = this;
      let count = 3;
      let u = window.navigator.userAgent;
      let isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
      let isAndroid = u.indexOf('Android') > -1 || u.indexOf('Adr') > -1; //android终端
      if(isiOS){
        let result = callback.result;
        callback.result = result.toString();
        window.webkit.messageHandlers.upload.postMessage(callback);
        // window.webkit.messageHandlers.upload.postMessage({
        //   fileSaveMode: '00',//存盘模式，默认值‘00’ 
        //   path: 'ITEM_PATH',//存盘路径，默认值‘ITEM_PATH’ 
        //   fieldId: this.field.divId,//表单控件id 
        //   applicationId: this.$root.appid,//软件应用id 
        //   count: count, // 文件数量，默认9，当文件数量1时，仅允许选择一个文件 
        //   sourceType: ['album', 'camera'],  //['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
        //   success: function (res) {
        //     let datas = JSON.parse(res);
        //     let arr = [];
        //     for(let i=0; i<datas.length; i++) {
        //       arr.push(datas[i].path);
        //     }
        //     that.field.value = arr;
        //   } 
        // });
      }else if(isAndroid){
        var _native = top.nativeAPI ? top.nativeAPI : nativeAPI;
        _native.upload({
          fileSaveMode: '00',//存盘模式，默认值‘00’ 
          path: 'ITEM_PATH',//存盘路径，默认值‘ITEM_PATH’ 
          fieldId: this.field.divId,//表单控件id 
          applicationId: this.$root.appid,//软件应用id 
          count: count, // 文件数量，默认9，当文件数量1时，仅允许选择一个文件 
          sourceType: ['album', 'camera'],  //['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
          success: function (res) {
            let datas = JSON.parse(res);
            let arr = [];
            for(let i=0; i<datas.length; i++) {
              arr.push(datas[i].path);
            }
            let val = that.field.imgURL;
            if(val) {
              val = val || [];
              val = val.concat(arr);
              that.field.value = val
            }else {
              that.field.value = arr //val.concat(arr);
            }
          } 
        })
      }
    },

    uploadFile(id) {
      let that = this;
      for(let i = 0; i < id.length; i++) {
        wx.uploadImage({
          localId: id[i],
          isShowProgressTips: 1,// 默认为1，显示进度提示
          success: function (res) {
            let serverId = res.serverId;
            that.$api.uploadWeixinPhoto(serverId,{
              onSucess: (response) => {
                if(response.data.data) {
                  let val = response.data.data;
                  that.photoURL.push(val);
                  that.field.value = that.photoURL;
                }
              }
            });
          },
          fail: function () {
            alert("网络异常，请再次尝试！");
          }
        });
      }
    },

  }
};
</script>

<style lang="scss" scoped>
.pic-wrap {
  width:100%;
  box-sizing: border-box;
  margin: 0 auto;
  display: -webkit-box;
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  align-items: center;
  background: #fff;
  border-bottom: 1px solid #e5e5e5;
  .add {
    width: 50px;
    height: 50px;
    margin: 8px 10px 20px 10px;
    position: relative;
    background: #f6f6f6;
    position: relative;
    .add-image {
      width: 50px;
      height: 50px;
      display: flex;
      justify-content: center;
      align-items: center;
      img {
        width: 40%;
        height: 31%;
      }
    }
    .close {
      width: 15px;
      height: 15px;
      font-size: 15px;
      position: absolute;
      top: -10px;
      right: -9px;
      color:#888888;
      background: #fff; 
    }
    .images {
      width: 50px;
      height: 50px;
      margin: 0;
      position: relative;
      
      img {
        width:50px;
        height: 50px;
      }
    }
  }
  .img-bg {
    background: white;
  }
  
}
.shoot-area {
  width: 100%;
  height: 200px;
  display: -webkit-box;
  display: flex;
  flex-direction: row;
  .left-take {
    width: 182px;
    height: 200px;
    margin-right: 70px;
    padding: 12px 10px;
    background: #c5dae9;
    box-shadow: 0px 3px 3px 1px rgba(0, 0, 0, 0.4);
    & > span {
      height: 18px;
      color: #0b333c;
      font-weight: bold;
    }
    .btn {
      float: right;
    }
  }
  .right-show {
    background: #c5dae9;
    box-shadow: 0px 3px 3px 1px rgba(0, 0, 0, 0.4);
    width: 182px;
    height: 200px;
    margin-right: 70px;
    padding: 12px 10px;
    & > span {
      height: 18px;
      color: #0b333c;
      font-weight: bold;
    }
  }
  .el-dialog__body {
    padding: 30px 20px;
    color: #606266;
    font-size: 14px;
    word-break: break-all;
    background: pink;
  }
}
</style>
